/*
 *  This file is part of PPP-Codes library: http://disa.fi.muni.cz/results/software/ppp-codes/
 *
 *  PPP-Codes library is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  PPP-Codes library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with PPP-Codes library.  If not, see <http://www.gnu.org/licenses/>.
 */
package pppcodes.ids;

import java.util.List;
import messif.objects.LocalAbstractObject;

/**
 * This interface translates object locators from string to integer and vice versa and stores the integer IDs within 
 *  the given data object (as IntKey). This interface is used by the version of PPP-Codes that manages internally an
 *  ID-object store.
 * 
 * @author David Novak, Masaryk University, Brno, Czech Republic, novak.david@gmail.com
 */
public interface ObjectLocatorConvertor extends LocatorStringIntConvertor {
  
    /**
     * Given a list of generated unique integer IDs this method returns the original string
     *  object locators for which this ID was generated by complementary {@link LocatorIntegerTranslator#getAndStoreIntLocator(messif.objects.LocalAbstractObject)}.
     * If this ID wasn't generated, null is returned.
     * @param ids integer value to get the original String locator for
     * @return array of the same length as the number of attributes passed; the items of the array contain
     *  string locators of corresponding id or null, if the locator was not resolved
     */
    public String [] getStringLocators(List<Integer> ids);

    /**
     * Given an object with a string locator, this method generates a unique integer ID and stores it to the
     *  object as an {@link IntegerKey}. If the object already contains an {@link IntegerKey}, nothing is changed. 
     *  The (new) integer is returned.
     * @param object data object to generate the int ID for
     * @return unique integer value for given string (data object locator)
     */
    public int getAndStoreIntLocator(LocalAbstractObject object);

}
